"""empty message

Revision ID: aea4a0f982b4
Revises: 
Create Date: 2018-11-28 17:07:11.577139

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = 'aea4a0f982b4'
down_revision = None
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('background_question',
    sa.Column('idbackground_question', sa.Integer(), nullable=False),
    sa.Column('background_question', sa.String(length=120), nullable=True),
    sa.Column('experiment_idexperiment', sa.Integer(), nullable=True),
    sa.PrimaryKeyConstraint('idbackground_question')
    )
    op.create_table('experiment',
    sa.Column('idexperiment', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(length=120), nullable=True),
    sa.Column('instruction', sa.Text(), nullable=True),
    sa.Column('directoryname', sa.String(length=120), nullable=True),
    sa.Column('language', sa.String(length=120), nullable=True),
    sa.Column('status', sa.String(length=120), nullable=True),
    sa.Column('randomization', sa.String(length=120), nullable=True),
    sa.Column('short_instruction', sa.Text(), nullable=True),
    sa.Column('single_sentence_instruction', sa.Text(), nullable=True),
    sa.Column('is_archived', sa.String(length=120), nullable=True),
    sa.Column('creator_name', sa.String(length=120), nullable=True),
    sa.Column('research_notification_filename', sa.String(length=120), nullable=True),
    sa.Column('creation_time', sa.DateTime(), nullable=True),
    sa.Column('stimulus_size', sa.String(length=120), nullable=True),
    sa.Column('consent_text', sa.Text(), nullable=True),
    sa.Column('use_forced_id', sa.String(length=120), nullable=True),
    sa.PrimaryKeyConstraint('idexperiment')
    )
    op.create_index(op.f('ix_experiment_consent_text'), 'experiment', ['consent_text'], unique=False)
    op.create_index(op.f('ix_experiment_creation_time'), 'experiment', ['creation_time'], unique=False)
    op.create_index(op.f('ix_experiment_directoryname'), 'experiment', ['directoryname'], unique=True)
    op.create_index(op.f('ix_experiment_instruction'), 'experiment', ['instruction'], unique=False)
    op.create_index(op.f('ix_experiment_name'), 'experiment', ['name'], unique=False)
    op.create_index(op.f('ix_experiment_short_instruction'), 'experiment', ['short_instruction'], unique=False)
    op.create_index(op.f('ix_experiment_single_sentence_instruction'), 'experiment', ['single_sentence_instruction'], unique=False)
    op.create_table('trial_randomization',
    sa.Column('idtrial_randomization', sa.Integer(), nullable=False),
    sa.Column('page_idpage', sa.Integer(), nullable=True),
    sa.Column('randomized_idpage', sa.Integer(), nullable=True),
    sa.Column('answer_set_idanswer_set', sa.Integer(), nullable=True),
    sa.Column('experiment_idexperiment', sa.Integer(), nullable=True),
    sa.PrimaryKeyConstraint('idtrial_randomization')
    )
    op.create_table('user',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('username', sa.String(length=64), nullable=True),
    sa.Column('email', sa.String(length=120), nullable=True),
    sa.Column('password_hash', sa.String(length=128), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_user_email'), 'user', ['email'], unique=True)
    op.create_index(op.f('ix_user_username'), 'user', ['username'], unique=True)
    op.create_table('answer_set',
    sa.Column('idanswer_set', sa.Integer(), nullable=False),
    sa.Column('experiment_idexperiment', sa.Integer(), nullable=True),
    sa.Column('session', sa.String(length=120), nullable=True),
    sa.Column('agreement', sa.String(length=120), nullable=True),
    sa.Column('answer_counter', sa.Integer(), nullable=True),
    sa.Column('registration_time', sa.DateTime(), nullable=True),
    sa.Column('last_answer_time', sa.DateTime(), nullable=True),
    sa.ForeignKeyConstraint(['experiment_idexperiment'], ['experiment.idexperiment'], ),
    sa.PrimaryKeyConstraint('idanswer_set')
    )
    op.create_index(op.f('ix_answer_set_last_answer_time'), 'answer_set', ['last_answer_time'], unique=False)
    op.create_index(op.f('ix_answer_set_registration_time'), 'answer_set', ['registration_time'], unique=False)
    op.create_table('background_question_option',
    sa.Column('idbackground_question_option', sa.Integer(), nullable=False),
    sa.Column('background_question_idbackground_question', sa.Integer(), nullable=True),
    sa.Column('option', sa.String(length=120), nullable=True),
    sa.ForeignKeyConstraint(['background_question_idbackground_question'], ['background_question.idbackground_question'], ),
    sa.PrimaryKeyConstraint('idbackground_question_option')
    )
    op.create_table('forced_id',
    sa.Column('idforced_id', sa.Integer(), nullable=False),
    sa.Column('experiment_idexperiment', sa.Integer(), nullable=True),
    sa.Column('pregenerated_id', sa.String(length=120), nullable=True),
    sa.ForeignKeyConstraint(['experiment_idexperiment'], ['experiment.idexperiment'], ),
    sa.PrimaryKeyConstraint('idforced_id')
    )
    op.create_table('page',
    sa.Column('idpage', sa.Integer(), nullable=False),
    sa.Column('experiment_idexperiment', sa.Integer(), nullable=True),
    sa.Column('type', sa.String(length=120), nullable=True),
    sa.Column('text', sa.String(length=120), nullable=True),
    sa.Column('media', sa.String(length=120), nullable=True),
    sa.ForeignKeyConstraint(['experiment_idexperiment'], ['experiment.idexperiment'], ),
    sa.PrimaryKeyConstraint('idpage')
    )
    op.create_index(op.f('ix_page_media'), 'page', ['media'], unique=False)
    op.create_index(op.f('ix_page_text'), 'page', ['text'], unique=False)
    op.create_index(op.f('ix_page_type'), 'page', ['type'], unique=False)
    op.create_table('question',
    sa.Column('idquestion', sa.Integer(), nullable=False),
    sa.Column('experiment_idexperiment', sa.Integer(), nullable=True),
    sa.Column('question', sa.String(length=120), nullable=True),
    sa.Column('left', sa.String(length=120), nullable=True),
    sa.Column('right', sa.String(length=120), nullable=True),
    sa.ForeignKeyConstraint(['experiment_idexperiment'], ['experiment.idexperiment'], ),
    sa.PrimaryKeyConstraint('idquestion')
    )
    op.create_table('answer',
    sa.Column('idanswer', sa.Integer(), nullable=False),
    sa.Column('question_idquestion', sa.Integer(), nullable=True),
    sa.Column('answer_set_idanswer_set', sa.Integer(), nullable=True),
    sa.Column('answer', sa.String(length=120), nullable=True),
    sa.Column('page_idpage', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['answer_set_idanswer_set'], ['answer_set.idanswer_set'], ),
    sa.ForeignKeyConstraint(['page_idpage'], ['page.idpage'], ),
    sa.ForeignKeyConstraint(['question_idquestion'], ['question.idquestion'], ),
    sa.PrimaryKeyConstraint('idanswer')
    )
    op.create_table('background_question_answer',
    sa.Column('idbackground_question_answer', sa.Integer(), nullable=False),
    sa.Column('answer_set_idanswer_set', sa.Integer(), nullable=True),
    sa.Column('answer', sa.String(length=120), nullable=True),
    sa.Column('background_question_idbackground_question', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['answer_set_idanswer_set'], ['answer_set.idanswer_set'], ),
    sa.ForeignKeyConstraint(['background_question_idbackground_question'], ['background_question.idbackground_question'], ),
    sa.PrimaryKeyConstraint('idbackground_question_answer')
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('background_question_answer')
    op.drop_table('answer')
    op.drop_table('question')
    op.drop_index(op.f('ix_page_type'), table_name='page')
    op.drop_index(op.f('ix_page_text'), table_name='page')
    op.drop_index(op.f('ix_page_media'), table_name='page')
    op.drop_table('page')
    op.drop_table('forced_id')
    op.drop_table('background_question_option')
    op.drop_index(op.f('ix_answer_set_registration_time'), table_name='answer_set')
    op.drop_index(op.f('ix_answer_set_last_answer_time'), table_name='answer_set')
    op.drop_table('answer_set')
    op.drop_index(op.f('ix_user_username'), table_name='user')
    op.drop_index(op.f('ix_user_email'), table_name='user')
    op.drop_table('user')
    op.drop_table('trial_randomization')
    op.drop_index(op.f('ix_experiment_single_sentence_instruction'), table_name='experiment')
    op.drop_index(op.f('ix_experiment_short_instruction'), table_name='experiment')
    op.drop_index(op.f('ix_experiment_name'), table_name='experiment')
    op.drop_index(op.f('ix_experiment_instruction'), table_name='experiment')
    op.drop_index(op.f('ix_experiment_directoryname'), table_name='experiment')
    op.drop_index(op.f('ix_experiment_creation_time'), table_name='experiment')
    op.drop_index(op.f('ix_experiment_consent_text'), table_name='experiment')
    op.drop_table('experiment')
    op.drop_table('background_question')
    # ### end Alembic commands ###
